=== vectorclass/CMakeLists.txt ===
add_library(vectorclass
instrset_detect.cpp
)
