## iqtree 1.3.11.1%2Bdfsg

=== debian/control ===
Source: iqtree
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               libeigen3-dev,
               libsprng2-dev,
               zlib1g-dev,
               help2man,
               time
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/iqtree.git
Vcs-Git: git://anonscm.debian.org/debian-med/iqtree.git
Homepage: http://www.cibiv.at/software/iqtree/

Package: iqtree
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: efficient phylogenetic software by maximum likelihood
 IQ-TREE is a very efficient maximum likelihood phylogenetic software
 with following key features among others:
 .
  * A novel fast and effective stochastic algorithm to estimate maximum
    likelihood trees. IQ-TREE outperforms both RAxML and PhyML in terms
    of likelihood while requiring similar amount of computing time (see
    Nguyen et al., 2015)
  * An ultrafast bootstrap approximation to assess branch supports (see
    Minh et al., 2013).
  * A wide range of substitution models for binary, DNA, protein, codon,
    and morphological alignments.
  * Ultrafast model selection for all data types, 10 to 100 times faster
    than jModelTest and ProtTest.
  * Finding best partition scheme like PartitionFinder.
  * Partitioned models with mixed data types for phylogenomic (multi-
    gene) alignments, allowing for separate, proportional, or joint
    branch lengths among genes.
  * Supporting the phylogenetic likelihod library (PLL) (see Flouri et
    al., 2014)
