=== debian/watch ===
version=3

opts="dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg" \
  https://github.com/Cibiv/IQ-TREE/releases .*/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
