## iqtree 1.4.3+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -37,15 +37,15 @@
 #NOTE: Static linking with clang windows: make a symlink libgcc_eh.a to libgcc.a (administrator required)
 # C:\TDM-GCC-64\lib\gcc\x86_64-w64-mingw32\5.1.0>mklink libgcc_eh.a libgcc.a
 
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 2.8.10 FATAL_ERROR)
 set(CMAKE_LEGACY_CYGWIN_WIN32 0)
 
 project(iqtree)
 add_definitions(-DIQ_TREE)
 # The version number.
 set (iqtree_VERSION_MAJOR 1)
-set (iqtree_VERSION_MINOR 3)
-set (iqtree_VERSION_PATCH "11.1") 
+set (iqtree_VERSION_MINOR 4)
+set (iqtree_VERSION_PATCH "3") 
 
 set(BUILD_SHARED_LIBS OFF)
 
@@ -113,6 +113,10 @@
 #	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++98")
 	set(CMAKE_CXX_FLAGS_RELEASE "-O3 -g")
 	set(CMAKE_C_FLAGS_RELEASE "-O3 -g")
+    # require at least gcc 4.6
+    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.6)
+        message(FATAL_ERROR "GCC version must be at least 4.6!")
+    endif()
 elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
 	message("Compiler      : Clang")
 	set(CLANG "TRUE")
@@ -331,7 +335,3 @@
 #include_directories("${PROJECT_BINARY_DIR}/zlib-1.2.7")
 
 
-##################################################################
-# subdirectories containing necessary libraries for the build 
-##################################################################
-add_subdirectory(pll)
