=== debian/changelog ===
iqtree (1.4.3+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Mon, 15 Aug 2016 22:24:55 +0200

iqtree (1.4.2+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
  * Use repack,compression=xz in d/watch instead of adding get-orig-source to
    d/rules
  * Do not use -m32 and -msse3 flags
    Closes: #813436
  * Do not append 32 to binary name if build on 32bit architecture
    Closes: #813437
  * Restrict binary to intel architecture
    Closes: #813438
  * cme fix dpkg-control
  * hardening=+all

  [ Christian Seiler ]
  * debian/rules:
     - parallel build
     - use variants to more elegantly build serial and omp executable
     - fix build time test
  * debian/patches/sse.patch
     - fix PLL_BYTE_ALIGNMENT to work around pll bug
     - fix SSE patch to properly build on amd64 and i386

 -- Andreas Tille <tille@debian.org>  Wed, 29 Jun 2016 13:38:33 +0200
