=== debian/control ===
--- 
+++ 
@@ -10,13 +10,13 @@
                zlib1g-dev,
                help2man,
                time
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/iqtree.git
-Vcs-Git: git://anonscm.debian.org/debian-med/iqtree.git
+Vcs-Git: https://anonscm.debian.org/git/debian-med/iqtree.git
 Homepage: http://www.cibiv.at/software/iqtree/
 
 Package: iqtree
-Architecture: any
+Architecture: amd64 hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: efficient phylogenetic software by maximum likelihood
