=== debian/rules ===
--- 
+++ 
@@ -2,30 +2,36 @@
 
 # DH_VERBOSE := 1
 
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
 pkg := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
 version=$(shell dpkg-parsechangelog -ldebian/changelog | grep Version: | cut -f2 -d' ' | cut -f1 -d- )
 mandir=$(CURDIR)/debian/$(pkg)/usr/share/man/man1/
-tmpompdir=$(CURDIR)/debian/tmp-omp/usr/bin
 
 %:
-	dh $@
+	dh $@ --parallel
 
-# Build first with OMP multiprocessing
-override_dh_auto_configure:
-	dh_auto_configure -- -DIQTREE_FLAGS="omp"
+VARIANTS = omp serial
 
-override_dh_auto_build:
-	dh_auto_build
-	mkdir -p $(tmpompdir)
-	cp -a `find $(CURDIR) -name iqtree-omp -type f -executable` $(tmpompdir)
-	# build again without OMP
-	dh_auto_clean
-	dh_auto_configure
-	dh_auto_build
+override_dh_auto_configure: $(foreach variant,$(VARIANTS),dh_auto_configure_$(variant))
+override_dh_auto_build:     $(foreach variant,$(VARIANTS),dh_auto_build_$(variant))
+override_dh_auto_install:   $(foreach variant,$(VARIANTS),dh_auto_install_$(variant))
+override_dh_auto_clean:     $(foreach variant,$(VARIANTS),dh_auto_clean_$(variant))
 
-override_dh_auto_install:
-	dh_auto_install
-	mv $(tmpompdir)/iqtree-omp debian/$(pkg)/usr/bin
+dh_auto_configure_omp:
+	dh_auto_configure -Bbuild.omp -- -DIQTREE_FLAGS="omp"
+
+dh_auto_configure_serial:
+	dh_auto_configure -Bbuild.serial -- -DIQTREE_FLAGS=""
+
+dh_auto_build_%:
+	dh_auto_build -Bbuild.$(subst dh_auto_build_,,$@)
+
+dh_auto_install_%:
+	dh_auto_install -Bbuild.$(subst dh_auto_install_,,$@)
+
+dh_auto_clean_%:
+	dh_auto_clean -Bbuild.$(subst dh_auto_clean_,,$@)
 
 override_dh_installexamples:
 	dh_installexamples
@@ -49,9 +55,6 @@
 #		ln -s iqtree-omp `dirname $$iqtreeomp`/iqtree ; \
 #	fi
 	sed '/ myprefix/,$$d' debian/Documents_source/example.sh > example.short
-	echo 'time $(tmpompdir)/iqtree-omp -s example.phy -omp 2' >> example.short
+	echo 'time $(CURDIR)/build.omp/iqtree-omp -s example.phy -omp 2	-redo' >> example.short
 	time sh example.short
 	rm example.short
-
-get-orig-source:
-	uscan --verbose --force-download --repack --compression xz
