=== model/CMakeLists.txt ===
add_library(model
modelgtr.cpp
modelbin.cpp
modeldna.cpp
modelfactory.cpp
modelnonrev.cpp
modelprotein.cpp
modelset.cpp
modelsubst.cpp
partitionmodel.cpp
rategamma.cpp
rategammainvar.cpp
rateheterogeneity.cpp
rateinvar.cpp
ratemeyerdiscrete.cpp
ratemeyerhaeseler.cpp
ratekategory.cpp
ratefree.cpp
ratefreeinvar.cpp
modelcodon.cpp
modelmorphology.cpp
modelmixture.cpp
)
