=== debian/changelog ===
iqtree (1.5.3+dfsg-2) unstable; urgency=medium

  [ Roger Shimizu ]
  * debian/rules:
    - Run dh_auto_test only if CPUs >= 2 (Closes: #854500).

  [ Andreas Tille ]
  * Implement remarks given by upstream
    (https://github.com/Cibiv/IQ-TREE/issues/17)

 -- Andreas Tille <tille@debian.org>  Sat, 11 Feb 2017 12:52:45 +0100

iqtree (1.5.3+dfsg-1) unstable; urgency=medium

  * New upstream version
  * debhelper 10
  * d/watch: version=4

 -- Andreas Tille <tille@debian.org>  Thu, 19 Jan 2017 08:36:11 +0100

iqtree (1.5.2+dfsg-1) unstable; urgency=medium

  * New upstream version 1.5.2+dfsg (Closes: #846958)
  * Enable build of MPI-parallelised executable

 -- Kevin Murray <kdmfoss@gmail.com>  Sun, 04 Dec 2016 11:25:38 +1100

iqtree (1.4.4+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Disable sse patch

 -- Andreas Tille <tille@debian.org>  Fri, 09 Sep 2016 11:07:13 +0200
