=== debian/control ===
--- 
+++ 
@@ -1,12 +1,14 @@
 Source: iqtree
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Andreas Tille <tille@debian.org>
+Uploaders: Andreas Tille <tille@debian.org>,
+           Kevin Murray <kdmfoss@gmail.com>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                cmake,
                libeigen3-dev,
                libsprng2-dev,
+               mpi-default-dev,
                zlib1g-dev,
                help2man,
                time
