=== debian/rules ===
--- 
+++ 
@@ -9,14 +9,17 @@
 mandir=$(CURDIR)/debian/$(pkg)/usr/share/man/man1/
 
 %:
-	dh $@ --parallel
+	dh $@
 
-VARIANTS = omp serial
+VARIANTS = omp serial mpi
 
 override_dh_auto_configure: $(foreach variant,$(VARIANTS),dh_auto_configure_$(variant))
 override_dh_auto_build:     $(foreach variant,$(VARIANTS),dh_auto_build_$(variant))
 override_dh_auto_install:   $(foreach variant,$(VARIANTS),dh_auto_install_$(variant))
 override_dh_auto_clean:     $(foreach variant,$(VARIANTS),dh_auto_clean_$(variant))
+
+dh_auto_configure_mpi:
+	dh_auto_configure -Bbuild.mpi -- -DIQTREE_FLAGS="mpi"
 
 dh_auto_configure_omp:
 	dh_auto_configure -Bbuild.omp -- -DIQTREE_FLAGS="omp"
@@ -47,6 +50,9 @@
 	help2man --no-info --no-discard-stderr --help-option="-h" \
 	    --name='efficient phylogenetic software by maximum likelihood (multiprocessor version)' \
 	    --version-string="$(version)" $(CURDIR)/debian/$(pkg)/usr/bin/iqtree-omp > $(mandir)/iqtree-omp.1
+	help2man --no-info --no-discard-stderr --help-option="-h" \
+	    --name='efficient phylogenetic software by maximum likelihood (multiprocessor version)' \
+	    --version-string="$(version)" $(CURDIR)/debian/$(pkg)/usr/bin/iqtree-mpi > $(mandir)/iqtree-mpi.1
 
 override_dh_auto_test:
 	# use only the first example for build time test to save time on autobuilders
@@ -54,7 +60,9 @@
 #		iqtreeomp=`find $(CURDIR) -name iqtree-omp -type f -executable` ; \
 #		ln -s iqtree-omp `dirname $$iqtreeomp`/iqtree ; \
 #	fi
+ifneq ($(shell nproc), 1)
 	sed '/ myprefix/,$$d' debian/Documents_source/example.sh > example.short
 	echo 'time $(CURDIR)/build.omp/iqtree-omp -s example.phy -omp 2	-redo' >> example.short
 	time sh example.short
 	rm example.short
+endif
