## iqtree 1.5.5+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -50,11 +50,11 @@
 # The version number.
 set (iqtree_VERSION_MAJOR 1)
 set (iqtree_VERSION_MINOR 5)
-set (iqtree_VERSION_PATCH "3")
+set (iqtree_VERSION_PATCH "5")
 
 set(BUILD_SHARED_LIBS OFF)
 
-if (CMAKE_C_COMPILER MATCHES "mpi")
+if (CMAKE_C_COMPILER MATCHES "mpic")
     set(IQTREE_FLAGS "${IQTREE_FLAGS} mpi")
 endif()
 
@@ -87,13 +87,13 @@
     add_definitions(-DWIN32)
 elseif (APPLE)
 	message("Target OS     : Mac OS X")
-	# to be compatible back to Mac OS X 10.6
+	# to be compatible back to Mac OS X 10.7
 	if (IQTREE_FLAGS MATCHES "oldmac")
 		add_definitions("-mmacosx-version-min=10.5")
 		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mmacosx-version-min=10.5")
 	else()
-		add_definitions("-mmacosx-version-min=10.6")
-		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mmacosx-version-min=10.6")
+		add_definitions("-mmacosx-version-min=10.7")
+		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mmacosx-version-min=10.7")
 	endif()
     SET(CMAKE_FIND_LIBRARY_SUFFIXES .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
 elseif (UNIX)
@@ -124,8 +124,13 @@
 	message("Compiler      : GNU Compiler (gcc)")
 	set(GCC "TRUE")
 #	set(COMBINED_FLAGS "-Wall -Wno-unused-function -Wno-sign-compare -pedantic -D_GNU_SOURCE -fms-extensions -Wno-deprecated")
-	set(CMAKE_CXX_FLAGS_RELEASE "-O3 -g")
-	set(CMAKE_C_FLAGS_RELEASE "-O3 -g")
+	set(CMAKE_CXX_FLAGS_RELEASE "-O3 -g -ffunction-sections -fdata-sections")
+	set(CMAKE_C_FLAGS_RELEASE "-O3 -g -ffunction-sections -fdata-sections")
+    if (APPLE)
+        set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -Wl,-dead_strip")
+    else()
+        set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -Wl,--gc-sections")
+    endif()
     # require at least gcc 4.8
     if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8)
         message(FATAL_ERROR "GCC version must be at least 4.8!")
@@ -139,12 +144,23 @@
 	message("Compiler      : Clang")
 	set(CLANG "TRUE")
 #	set(COMBINED_FLAGS "-Wall -Wno-unused-function -Wno-sign-compare -pedantic -D_GNU_SOURCE -Wno-nested-anon-types")
-    #if (APPLE AND NOT CMAKE_BUILD_TYPE MATCHES "Debug")
-    #    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
-    #    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -stdlib=libc++")
-    #endif()
-	set(CMAKE_CXX_FLAGS_RELEASE "-O3")
-	set(CMAKE_C_FLAGS_RELEASE "-O3")
+    set(CMAKE_CXX_FLAGS_RELEASE "-O3 -ffunction-sections -fdata-sections")
+    set(CMAKE_C_FLAGS_RELEASE "-O3 -ffunction-sections -fdata-sections")
+    if (APPLE)
+        set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -Wl,-dead_strip")
+    else()
+        set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -Wl,--gc-sections")
+    endif()
+
+    # use libc++ per default in MacOS
+    if (APPLE AND CMAKE_BUILD_TYPE MATCHES "Release")
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
+    endif()
+
+    #remove -rdynamic for Clang under Linux
+    if (UNIX AND IQTREE_FLAGS MATCHES "static")
+        SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS)
+    endif()
 elseif (CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
 	set(VCC "TRUE")
 	message("Compiler      : MS Visual C++ Compiler")
@@ -173,6 +189,15 @@
 	endif()
 endif()
 
+# enable link time optimization
+if (IQTREE_FLAGS MATCHES "lto")
+    #if (CLANG)
+    #    set(COMBINED_FLAGS "${COMBINED_FLAGS} -flto=thin")
+    #else()
+        set(COMBINED_FLAGS "${COMBINED_FLAGS} -flto")
+    #endif()
+endif()
+
 ##################################################################
 # configure MPI compilation
 ##################################################################
@@ -239,9 +264,11 @@
   		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /openmp")
   		include_directories("${PROJECT_SOURCE_DIR}/pll") # for PThreads headers
 	elseif (ICC)
-  		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qopenmp")
   		if (WIN32)
+            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qopenmp")
   			include_directories("${PROJECT_SOURCE_DIR}/pll") # for PThreads headers
+        else()
+            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -qopenmp")
   		endif()
   	elseif (GCC)
 		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
@@ -275,7 +302,7 @@
 	set(AVX_FLAGS "${AVX_FLAGS} -mavx -fabi-version=0")
 elseif (ICC)
 	if (WIN32)
-		 set(AVX_FLAGS "${AVX_FLAGS} /arch:AVX")
+		 set(AVX_FLAGS "${AVX_FLAGS} /arch:avx")
 	else()
 		 set(AVX_FLAGS "${AVX_FLAGS} -mavx")
 	endif()
@@ -288,7 +315,7 @@
 	set(SSE_FLAGS "${SSE_FLAGS} -msse3")
 elseif (ICC)
 	if (WIN32)
-		set(SSE_FLAGS "${SSE_FLAGS} /arch:SSE3")
+		set(SSE_FLAGS "${SSE_FLAGS} /arch:sse3")
 	else()
 		set(SSE_FLAGS "${SSE_FLAGS} -msse3")
 	endif()
@@ -303,7 +330,7 @@
 	set(FMA_FLAGS "${FMA_FLAGS} -mavx -fabi-version=0 -mfma")
 elseif (ICC) 
 	if (WIN32)
-		 set(FMA_FLAGS "${FMA_FLAGS} /arch:AVX /Qfma")
+		 set(FMA_FLAGS "${FMA_FLAGS} /arch:core-avx2")
 	else()
 		 set(FMA_FLAGS "${FMA_FLAGS} -march=core-avx2")
 	endif()
@@ -311,31 +338,3 @@
 
 SET(AVX512_FLAGS "-D__SSE3 -D__AVX")
 if (VCC)
-    message("AVX512 not available in Visual C++")
-	#set(AVX512_FLAGS "${AVX512_FLAGS} /arch:AVX512")
-elseif (CLANG)
-	set(AVX512_FLAGS "${AVX512_FLAGS} -mavx512f -mfma")
-elseif (GCC)
-	set(AVX512_FLAGS "${AVX512_FLAGS} -mavx512f -mfma")
-elseif (ICC) 
-	if (WIN32)
-		 set(AVX512_FLAGS "${AVX512_FLAGS} /arch:MIC-AVX512 /Qfma")
-	else()
-		 set(AVX512_FLAGS "${AVX512_FLAGS} -xMIC-AVX512 -mfma")
-	endif()
-endif()
-
-
-# further flag to improve performance
-
-if (IQTREE_FLAGS MATCHES "fma") # AVX+FMA instruction set
- 	message("Vectorization : AVX+FMA")
-	add_definitions(-D__SSE3 -D__AVX) # define both SSE3 and AVX directive
-    set(COMBINED_FLAGS "${COMBINED_FLAGS} ${FMA_FLAGS}")
-	#SET(EXE_SUFFIX "${EXE_SUFFIX}-fma")
-elseif (IQTREE_FLAGS MATCHES "avx") # AVX instruction set
- 	message("Vectorization : AVX")
-	add_definitions(-D__SSE3 -D__AVX) # define both SSE3 and AVX directive
-	set(COMBINED_FLAGS "${COMBINED_FLAGS} ${AVX_FLAGS}")
-	#SET(EXE_SUFFIX "${EXE_SUFFIX}-avx")
-elseif (NOT IQTREE_FLAGS MATCHES "nosse") #SSE intruction set
