=== debian/changelog ===
iqtree (1.5.5+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Mon, 19 Jun 2017 08:58:16 +0200
